$regfile = "attiny2313.dat"
$crystal = 8000000

'--- configure the 4 buttons ---
Config Pina.0 = Input
Config Pina.1 = Input
Config Pind.0 = Input
Config Pind.1 = Input
Config Portd.4 = Output

'--- configure the LCD ---
Config Lcdpin = Pin , Rs = Portb.7 , E = Portb.6 , Db4 = Portb.5 , Db5 = Portb.4 , Db6 = Portb.3 , Db7 = Postb.2
Config Lcd = 16 * 2

'--- configure variables ---
Dim Mnuitem As Byte
Dim X As Byte
Dim S As Byte
Dim Strtmp As String * 16
Dim Values(3) As Byte
Dim Tmpval As Byte

Open "comd.2:2400,8,n,1" For Output As #1
Baud #1 , 2400

Cls
Lcd "*Stairs control*"
Lowerline
Lcd "Wauters Kris (C)"
Mnuitem = 0
Waitms 500
Gosub Readvalues:

'--- main loop ---
Do
   '--- loop trough menu ---
   If Pina.0 = 1 Then
      Mnuitem = Mnuitem + 1
      If Mnuitem > 3 Then Mnuitem = 1
      Gosub Showmenuitem
      Waitms 500
   End If
   '--- turn value 1 up ---
   If Pina.1 = 1 Then
      Values(mnuitem) = Values(mnuitem) + 1
      Tmpval = Lookup(mnuitem , Maxlimits)
      If Values(mnuitem) > Tmpval Then
         Tmpval = Lookup(mnuitem , Minlimits)
         Values(mnuitem) = Tmpval
      End If
      Gosub Showmenuitem
      Waitms 150
   End If
   '--- turn value 1 down ---
   If Pind.1 = 1 Then
      Values(mnuitem) = Values(mnuitem) - 1
      Tmpval = Lookup(mnuitem , Minlimits)
      If Values(mnuitem) < Tmpval Then
         Tmpval = Lookup(mnuitem , Maxlimits)
         Values(mnuitem) = Tmpval
      End If
      Gosub Showmenuitem
      Waitms 150
   End If
   '--- write current values to main controller via I2C ---
   If Pind.0 = 1 Then
      Cls
      Lcd "Wait please ... "
      Lowerline
      Lcd "                "
      Gosub Writevalues
      Cls
      Lcd "Data written to "
      Lowerline
      Lcd "EEPROM memory ! "
   End If
Loop

'--- retrieve the 3 values from the main controller via I2C ---
Readvalues:
   For X = 1 To 3
      Readeeprom Values(x) , X
   Next X
Return

'--- write the 3 values to the main controller via I2C ---
Writevalues:
   Portd.4 = 1
   Waitms 1000
   Portd.4 = 0
   For X = 3 To 1 Step -1
      Put #1 , Values(x)
      Writeeeprom Values(x) , X
      Waitms 500
   Next X
Return


'--- show the current menu item and corresponding value ---
Showmenuitem:
   Cls
   Lcd Lookupstr(mnuitem , Menuitems)
   Lowerline
   Lcd Str(values(mnuitem))
Return

Menuitems:
Data " " , "# Ports (1-12)  " , "Interval (msec) " , "Time-out (sec)  "

Minlimits:
Data 0 , 1 , 1 , 1

Maxlimits:
Data 0 , 12 , 254 , 240