$regfile = "attiny2313.dat"
$crystal = 8000000

'--- 12 output poorten, voor 12 LEDs ---
Config Portb = Output
Config Portd.6 = Output
Config Portd.5 = Output
Config Portd.3 = Output
Config Portd.1 = Output

'--- PINA.0 & PINA.1 zijn laser lichtsluizen, pin D.0 is lichtsensor ---
Config Pind.0 = Input
Config Pina.0 = Input
Config Pina.1 = Input

'--- PIND.2 & PIND.4 zijn voor I2C communicatie met config-tooltje ---
Config Pind.4 = Input

'--- variabel definities ---
Dim X As Byte                                               '--- buitenste tellertje voor PWM
Dim Y As Byte                                               '--- binnenste tellertje voor PWM
Dim Tmr As Word                                             '--- timer voor timeout
Dim Tmrref As Word
Dim Led(12) As Byte                                         '--- array met de status van de 12 LEDs
Dim Onoff As Byte                                           '--- on/off status voor LED actie
Dim Curpos As Byte                                          '--- teller voor LEDs af te lopen
Dim Curpos2 As Byte                                         '--- teller voor LEDs af te lopen
Dim Direction As Byte                                       '--- richting voor LED actie
Dim Nrports As Byte
Dim Interval As Byte
Dim Timeout As Byte
Dim S As Byte
Dim W As Byte
Dim Z As Byte

'--- initialiseer variabelen bij start van microcontroller ---
Onoff = 0
Direction = 0

Waitms 1000
Open "comd.2:2400,8,n,1" For Input As #1
Baud #1 , 2400
Readeeprom Nrports , 1
Readeeprom Interval , 2
Readeeprom Timeout , 3

'--- oneindige programma-lus (hoofdlus) ---
Do
   '--- als config tool op controller zit, voer dan ander stuk programma uit ---
   If Pind.4 = 1 Then
      Gosub Configure
   End If
   If Pind.0 = 1 Then                                       '--- alleen uitvoeren indien lichtsensor geactiveerd
      If Pina.0 = 1 Then                                    '--- lichtsluis 1 geactiveerd
         '--- zet LEDs aan/uit, afhankelijk van huidige status
         Onoff = 1 - Onoff
         Direction = 2 - Onoff
         Gosub Ledloop
      End If
      If Pina.1 = 1 Then                                    '--- lichtsluis 2 geactiveerd
         '--- zet LEDs aan/uit, afhankelijk van huidige status ---
         Onoff = 1 - Onoff
         Direction = 1 + Onoff
         Gosub Ledloop
      End If
   End If
   '--- also do the following, even if external light is bright :-) ---
   If Onoff = 1 Then
      Tmr = Tmr + 1
      Waitms 10
      '--- na wachtperiode, doe alle LEDs terug uit ---
      Tmrref = 99 * Timeout
      If Tmr = Tmrref Then
         Direction = 3 - Direction
         Onoff = 0
         Gosub Automaticoff:
      End If
   End If
Loop

'--- Hoofdlus voor LEDs af te lopen ---
Ledloop:
   Select Case Direction
   Case 1:
      '--- loop voorwaarts ---
      For Curpos = 1 To Nrports
         Curpos2 = Curpos
         Gosub Doled
      Next Curpos
   Case 2:
      '--- loop achterwaarts ---
      For Curpos = Nrports To 1 Step -1
         Curpos2 = Curpos
         Gosub Doled
      Next Curpos
   End Select
   Tmr = 0
Return

'--- when timeout expires, turnoff automatically ---
Automaticoff:
   S = Nrports / 2

   For W = S To 0 Step - 1
      Curpos = W
      Curpos2 = Nrports
      Curpos2 = Curpos2 - W
      Gosub Doled:
    Next Z
Return

'--- PWM huidige LED ---
Doled:
   For X = 0 To 32
      For Y = X To 32
         Led(curpos) = 1 - Onoff
         Led(curpos2) = 1 - Onoff
         Gosub Setled
         For Z = 1 To Interval
            Waitus 1
         Next Z
      Next Y
      For Y = 0 To X
         Led(curpos) = Onoff
         Led(curpos2) = Onoff
         Gosub Setled
         For Z = 1 To Interval
            Waitus 1
         Next Z
      Next Y
   Next X
Return

'--- Zet LED variabelen naar pinnen ---
Setled:
   Portd.1 = Led(1)
   Portd.3 = Led(2)
   Portd.5 = Led(3)
   Portd.6 = Led(4)
   Portb.0 = Led(5)
   Portb.1 = Led(6)
   Portb.2 = Led(7)
   Portb.3 = Led(8)
   Portb.4 = Led(9)
   Portb.5 = Led(10)
   Portb.6 = Led(11)
   Portb.7 = Led(12)
Return

'--- stuk software om configuratie te wijzigen ---
Configure:
   For X = 1 To 12
      Led(x) = 1
   Next X
   Gosub Setled:
   '--- get 3 bytes and write them to eeprom ---
   For X = 3 To 1 Step -1
      Get #1 , Z
      Writeeeprom Z , X
   Next X
   Readeeprom Nrports , 1
   Readeeprom Interval , 2
   Readeeprom Timeout , 3
   For X = 1 To 12
      Led(x) = 0
   Next X
   Gosub Setled:
Return